'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('ztree');

require('./react-ztree.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * React-Ztree
 *
 * @version 1.0.0
 * @author NKIA
 */
var ZTree = function (_React$Component) {
    _inherits(ZTree, _React$Component);

    function ZTree(props) {
        _classCallCheck(this, ZTree);

        var _this = _possibleConstructorReturn(this, (ZTree.__proto__ || Object.getPrototypeOf(ZTree)).call(this, props));

        _this.onClickHandler = function (event, treeId, treeNode) {
            _this.selectedNodeId = treeNode.id;
        };

        _this.getAsyncUrl = function (treeId, treeNode) {
            var leafId = treeNode ? treeNode.id : -1;
            return _this.props.url + '/' + leafId;
        };

        _this.addNodes = function (parentNode) {
            var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
            var newNodes = arguments[2];
            var isSlient = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

            _this.treeObj.addNodes(parentNode, index, newNodes, isSlient);
        };

        _this._dataFilterHandler = function (treeId, parentNode, responseData) {
            if (_this.props.dataFilterKey !== null && _this.props.dataFilterKey.length > 0) {
                var filterKeyArray = _this.props.dataFilterKey.split('.');
                for (var i in filterKeyArray) {
                    responseData = responseData[filterKeyArray[i]];
                }
            }
            return responseData;
        };

        _this._expandNodeHandler = function (event, treeId, treeNode) {
            if (_this.props.expandNodeLevel > 0) {
                var treeObj = _jquery2.default.fn.zTree.getZTreeObj(_this.props.treeId);
                if (treeNode.level < _this.props.expandNodeLevel) {
                    treeObj.expandNode(treeNode, true, false, false);
                }
            }
        };

        var iconClass = _this.props.iconClass;

        /**
         * zTree Object Override
         * Icon 생성 부분 처리
         */

        Object.assign(_jquery2.default.fn.zTree._z.view, {
            makeDOMNodeIcon: function makeDOMNodeIcon(html, setting, node) {
                var consts = _jquery2.default.fn.zTree.consts;
                var data = _jquery2.default.fn.zTree._z.data;
                var view = _jquery2.default.fn.zTree._z.view;

                var nameStr = data.getNodeName(setting, node),
                    name = setting.view.nameIsHTML ? nameStr : nameStr.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');

                if (node.iconSkin && Array.isArray(node.iconSkin)) {
                    var iconHtml = [];
                    iconHtml.push("<span id='", node.tId, consts.id.ICON, "' title='' treeNode", consts.id.ICON, " class='fa-stack ", "' style='", view.makeNodeIcoStyle(setting, node), "'>");
                    node.iconSkin.forEach(function (skin) {
                        iconHtml.push("<i class='fa " + skin + "'></i>");
                    });
                    iconHtml.push("</span>");

                    html.push(iconHtml.join('') + "<span id='", node.tId, consts.id.SPAN, "' class='", consts.className.NAME, "'>", name, "</span>");
                } else {
                    html.push("<span id='", node.tId, consts.id.ICON, "' title='' treeNode", consts.id.ICON, " class='", view.makeNodeIcoClass(setting, node), "' style='", view.makeNodeIcoStyle(setting, node), "'></span><span id='", node.tId, consts.id.SPAN, "' class='", consts.className.NAME, "'>", name, "</span>");
                }
            },
            makeNodeIcoClass: function makeNodeIcoClass(setting, node) {
                var consts = _jquery2.default.fn.zTree.consts;
                // iconSkin이 font-awesome인 경우에 처리
                if (node.iconSkin && iconClass === 'font-awesome') {
                    return 'fa ' + node.iconSkin;
                }

                var icoCss = ['ico'];
                if (!node.isAjaxing) {
                    icoCss[0] = (node.iconSkin ? node.iconSkin + '_' : '') + icoCss[0];
                    if (node.isParent) {
                        icoCss.push(node.open ? consts.folder.OPEN : consts.folder.CLOSE);
                    } else {
                        icoCss.push(consts.folder.DOCU);
                    }
                }
                return consts.className.BUTTON + ' ' + icoCss.join('_');
            }
        });
        return _this;
    }

    _createClass(ZTree, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _props = this.props,
                treeId = _props.treeId,
                treeObj = _props.treeObj;
            /**
             * aync properties
             */

            var _props2 = this.props,
                autoParam = _props2.autoParam,
                contentType = _props2.contentType,
                dataFilter = _props2.dataFilter,
                dataType = _props2.dataType,
                ayncEnable = _props2.ayncEnable,
                otherParam = _props2.otherParam,
                type = _props2.type,
                url = _props2.url;
            /**
             * callback properties
             */

            var beforeAsync = this.props.beforeAsync;
            /**
             * checkbox properties
             */

            var _props3 = this.props,
                checkboxEnable = _props3.checkboxEnable,
                chkboxType = _props3.chkboxType,
                chkStyle = _props3.chkStyle;
            /**
             * simpleData properties
             */

            var _props4 = this.props,
                simpleDataEnable = _props4.simpleDataEnable,
                pIdKey = _props4.pIdKey,
                idKey = _props4.idKey,
                rootPid = _props4.rootPid;
            /**
             * view properties
             */

            var _props5 = this.props,
                fontCss = _props5.fontCss,
                nameIsHTML = _props5.nameIsHTML;

            /**
             * Custom properties
             */

            var _props6 = this.props,
                nodes = _props6.nodes,
                expandNodeLevel = _props6.expandNodeLevel,
                nodeState = _props6.nodeState;


            var setting = {
                treeId: treeId,
                treeObj: treeObj,
                async: {
                    autoParam: autoParam,
                    contentType: contentType,
                    dataFilter: dataFilter,
                    dataType: dataType,
                    otherParam: otherParam,
                    type: type,
                    url: url,
                    enable: ayncEnable
                },
                callback: {
                    beforeAsync: beforeAsync
                },
                check: {
                    enable: checkboxEnable,
                    chkboxType: chkboxType,
                    chkStyle: chkStyle
                },
                data: {
                    simpleData: {
                        enable: simpleDataEnable,
                        pIdKey: pIdKey,
                        idKey: idKey,
                        rootPid: rootPid
                    }
                },
                view: {
                    fontCss: fontCss,
                    nameIsHTML: nameIsHTML
                }
            };

            if (url) {
                Object.assign(setting.async, {
                    enable: true,
                    dataFilter: this._dataFilterHandler
                });
            }

            if (expandNodeLevel > 0) {
                // 최초 Root Node 확장을 위함
                Object.assign(setting.callback, {
                    onNodeCreated: this._expandNodeHandler
                });
            }

            if (nodeState) {
                Object.assign(setting.callback, {
                    onClick: this.onClickHandler
                });
            }

            if (_lodash2.default.isEmpty(nodes)) {
                this.treeObj = _jquery2.default.fn.zTree.init((0, _jquery2.default)('#' + treeId), setting);
            } else {
                this.treeObj = _jquery2.default.fn.zTree.init((0, _jquery2.default)('#' + treeId), setting, nodes);
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            var treeId = this.props.treeId;


            if (this.props.nodes.length !== nextProps.nodes.length || nextProps.nodes.length > 0) {
                // 기존 tree를 제거하고 새로 생성한다.
                var setting = this.treeObj.setting;
                this.treeObj.destroy(treeId);
                this.treeObj = _jquery2.default.fn.zTree.init((0, _jquery2.default)('#' + treeId), setting, nextProps.nodes);
            }
            return false;
        }

        /**
         * Tree 노드 추가
         *
         * @param {string} parentNode
         * @param {number} index
         * @param {array} newNodes
         * @param {bool} isSlient
         * @public
         */

    }, {
        key: 'expandAll',


        /**
         * Tree 전체 확장
         *
         * @public
         */
        value: function expandAll() {
            this.treeObj.expandAll(true);
        }

        /**
         * Tree 전체 접기
         *
         * @public
         */

    }, {
        key: 'collpaseAll',
        value: function collpaseAll() {
            this.treeObj.expandAll(false);
        }

        /**
         * Tree 새로고침
         *
         * @public
         */

    }, {
        key: 'refresh',
        value: function refresh() {
            this.treeObj.refresh();
        }

        /**
         * Tree Async - 응답 데이터에 대한 데이터 필터 핸들러
         *
         * @param treeId
         * @param parentNode
         * @param responseData
         * @returns {*}
         * @private
         */


        /**
         * Tree 레벨 확장에서 사용되는 핸들러
         *
         * @param event
         * @param treeId
         * @param treeNode
         * @private
         */

    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement('ul', { id: this.props.treeId, className: 'ztree' });
        }
    }]);

    return ZTree;
}(_react2.default.Component);

ZTree.propTypes = {
    /** zTree unique identifier. After the initialization, it equals to the id attribute value of the user-defined zTree container. */
    treeId: _propTypes2.default.string,
    /**
     * zTree DOM's jQuery object, the main function: easy to internal operations.
     */
    treeObj: _propTypes2.default.object,
    /**
     * During asynchronous loading, a request is sent to the server, which contains the identify of the parent node, so it can retrieve the children. This attribute is an array of strings, which is the identity parameter (or parameters). It applies when [setting.async.enable = true]
     */
    autoParam: _propTypes2.default.array,
    /**
     * When Ajax sends data to the server, it uses this content-type. It is used when [setting.async.enable = true]
     */
    contentType: _propTypes2.default.string,
    /**
     * Callback function to pre-process Ajax return data. It is valid when [setting.async.enable = true]
     */
    dataFilter: _propTypes2.default.func,
    /**
     * The data type of Ajax requests. It is valid when [setting.async.enable = true]
     */
    dataType: _propTypes2.default.string,
    /**
     * Set zTree asynchronous loading mode on/off.
     */
    ayncEnable: _propTypes2.default.bool,
    /**
     * The query parameters of the Ajax request. (key - value) It is valid when [setting.async.enable = true]
     */
    otherParam: _propTypes2.default.array,
    /**
     * Http request tyoe in ajax. It is valid when [setting.async.enable = true]
     */
    type: _propTypes2.default.string,

    /**
     * The URL to which the ajax request is sent. It is valid when [setting.async.enable = true]
     */
    url: _propTypes2.default.string,

    /**
     * This callback is made before zTree makes an ajax request, giving you an opportunity to decide if it should proceed or not. Return false to prevent zTree from sending the ajax request.
     */
    beforeAsync: _propTypes2.default.func,

    /**
     * When one node is checked or unchecked, control its parent node and its child node auto checked or unchecked. It is valid when [setting.check.enable = true & setting.check.chkStyle = "checkbox"]
     */
    chkboxType: _propTypes2.default.object,

    /**
     * Set to use checkbox or radio in zTree
     */
    checkboxEnable: _propTypes2.default.bool,

    /**
     * Use the checkbox or radio. It is valid when [setting.check.enable = true]
     */
    chkStyle: _propTypes2.default.string,

    /**
     * Personalized text style, only applies to <A> object in the node DOM
     */
    fontCss: _propTypes2.default.object,

    /**
     * Set to use HTML in 'name' attribute.
     */
    nameIsHTML: _propTypes2.default.bool,

    /**
     * The node data's attribute to save its parent node data's unique identifier. It is valid when [setting.data.simpleData.enable = true]
     */
    pIdKey: _propTypes2.default.string,

    /**
     * The node data's attribute to save node data's unique identifier. It is valid when [setting.data.simpleData.enable = true]
     */
    idKey: _propTypes2.default.string,

    /**
     * Set the default value of root's 'pIdKey' specified attribute values​​. It is valid when [setting.data.simpleData.enable = true]
     */
    rootPid: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),

    /**
     * Ajax 요청에 대한 데이터 추출 Key(JSON 구조)
     */
    dataFilterKey: _propTypes2.default.string,

    /**
     * 사용자 정의 데이터
     */
    nodes: _propTypes2.default.array,

    /**
     * Icon 기본 클래스 정의
     */
    iconClass: _propTypes2.default.string,

    /**
     * Tree 확장 레벨 설정
     */
    expandNodeLevel: _propTypes2.default.number,

    /**
     * Tree Node의 상태를 저장(미구현)
     */
    nodeState: _propTypes2.default.bool,

    /**
     * Set zTree's node to accept the simple data format, when zTree is initialized or when ajax get / or when use addNodes method.
     * Don't have to generate the complex nested data
     */
    simpleDataEnable: _propTypes2.default.bool
};
ZTree.defaultProps = {
    treeId: 'treeContainer',
    treeObj: null,
    autoParam: [],
    contentType: 'application/x-www-form-urlencoded',
    dataFilter: null,
    dataType: 'text',
    ayncEnable: false,
    otherParam: [],
    type: 'post',
    url: '',
    beforeAsync: null,
    chkboxType: { Y: 'ps', N: 'ps' },
    checkboxEnable: false,
    chkStyle: 'checkbox',
    fontCss: {},
    nameIsHTML: false,
    simpleDataEnable: true,
    idKey: 'id',
    pIdKey: 'pId',
    rootPid: null,

    nodes: [],
    iconClass: 'font-awesome',
    expandNodeLevel: 0,
    dataFilterKey: null,
    nodeState: false
};
exports.default = ZTree;